/*
 * QEMU Hyper-V/Util protocol definitions
 *
 * Copyright (c) 2018 Virtuozzo International GmbH.
 *
 * This work is licensed under the terms of the GNU GPL, version 2 or later.
 * See the COPYING file in the top-level directory.
 */

#ifndef HV_UTIL_PROTO_H
#define HV_UTIL_PROTO_H

#include "qemu/osdep.h"

struct vmbuspipe_hdr {
    uint32_t flags;
    uint32_t msgsize;
} QEMU_PACKED;

struct ic_version {
    uint16_t major;
    uint16_t minor;
} QEMU_PACKED;

#define ICMSGTYPE_NEGOTIATE 0
#define ICMSGTYPE_HEARTBEAT 1
#define ICMSGTYPE_KVPEXCHANGE 2
#define ICMSGTYPE_SHUTDOWN 3
#define ICMSGTYPE_TIMESYN 4
#define ICMSGTYPE_VSS 5

#define ICMSGHDRFLAG_TRANSACTION 1
#define ICMSGHDRFLAG_REQUEST 2
#define ICMSGHDRFLAG_RESPONSE 4

struct icmsg_hdr {
    struct ic_version icverframe;
    uint16_t icmsgtype;
    struct ic_version icvermsg;
    uint16_t icmsgsize;
    uint32_t status;
    uint8_t ictransaction_id;
    uint8_t icflags;
    uint8_t reserved[2];
} QEMU_PACKED;

#define HV_UTIL_FW_MAJOR 3
#define HV_UTIL_FW_MINOR 0

struct icmsg_negotiate {
    uint16_t icframe_vercnt;
    uint16_t icmsg_vercnt;
    uint32_t reserved;
    struct ic_version icversion_data[];
} QEMU_PACKED;

#endif
